-- +------------------------------------------------------------------------------+
-- | 																			  |
-- |		                      WWWWWQ                                          |
-- |		                    9M..~;iTMk                                        |
-- |		                  kM~.  ..,~ioMk                                      |
-- |		                kM=.  ``,"<=vhWK                'MMMMMv               |
-- |		              vM=.  ``,,_~v7jUWK                `***aWY               |
-- |		            vMY.  ``:,__<!jy@K.`              'MMMD=SWY               |
-- |		          /MY.` ``',__<<vn@$.`               M8,<W@MP.`               |
-- |		        /Mh.`  `',__^<vvjFSEMk             MM,~<vWp.`                 |
-- |		      'Mh.`  `-,__|<lvjj@NJCSUMk   vMMMMMMM,,<vM8.`                   |
-- |		    'M#.`  `-,__|<cvxj@@sT<^:/SUMMMS~=*8W^_<<M@WQ                     |
-- |		   M#.`  `.,__;<cvzj%@ss7c'':~>oW5~/+6Ml_^<MMW&.`                     |
-- |		 MMWWMMMU,,_;<rvzj$@es77<^::'?MA~/+GMv,/<&MWW*YM9                     |
-- |		 WW8RSnioM6<rvCj$@XsJ7<<''';Mb~|+GMS,/<6MWW**=<~,                     |
-- |		 WW!!>^,,"vMMMS"?sr<,:,,-;MQ*eMK'|*KMMM!.&Wll__::'?MMMMMMM/           |
-- |		 ..Mg `'':vW5~,'|<"'::'':,~=Mb,lMMM@WWWMM~-,,:::::;*aWWWWW<           |
-- |		   WQ   `':~,''::'::''::';M8,lM4-:~~~~~~~:':::::::~=SWWWWW<           |
-- |		   .~M9   `'':''::''::'':^W%<oW@MMMh+++++,::::::::~=SWWWWW<           |
-- |		     .~Mk   `'':''::''::.~WWMP..':"SMMMMMv++++++^:~=SWWWWW<           |
-- |		       .=Mk   `'::''::..  ....`.-':|i8Wi.8MMMMMM&+>=SWWWWW<           |
-- |		         .=Mv   .'::..  ``  `.-':~^*1QW< `......~MMM@WWWWW<           |
-- |		           .YMv   `.  ``  ``-':~^*16@!.          ...iWWWWW<           |
-- |		            `.YM/   ``    -':~^i16@j.                .....            |
-- |	   	           `.hM/     `.:,^i1K@j.`                                     |
-- |		              vMGsmM' ``-:^>1K@K.`                                    |
-- |		            vMOsT7$W"`--:~1e@K.`                                      |
-- |	    	      /MOsl<~:"~8M^^zl``.`                                        |
-- |		          <WK<~'::` QW11@8                                            |
-- |		           .xM2:` -:&W@@.`                                            |
-- |	    	        `.)MMMMMWW..            	                              |
-- | 																			  |
-- | dISK iN pLACE                                                                |
-- | Versione 0.3                                                                 |
-- | Garantisce che le finestre siano zoomate ed entrino nello schermo corrente)  |
-- | mORA 20090121 1720                                                           |
-- +------------------------------------------------------------------------------+
-- | (R | 20080224 1243)                                                          |
-- | (R | 20070119)                                                               |
-- | (R | 20060508)                                                               |
-- | (R | 20051102)                                                               |
-- +------------------------------------------------------------------------------+
-- | Vengono usate le seguenti costanti:                                          |
-- +------------------------------------------------------------------------------+
-- | global vFinderVersion                 - La versione corrente del FInder
-- | global kWindowsDistanceX              - distanza orizzontale tra la finestra ed il Desktop
-- | global kWindowsDistanceY              - distanza verticale tra la finestra ed il Desktop (in realt dalla MenuBar)
-- | global kWindowsDeltaX                 - distanza orizzontale dalla finestra madre
-- | global kWindowsDeltaY                 - distanza verticale dalla finestra madre
-- +------------------------------------------------------------------------------+
-- | Vengono usate le seguenti variabili:                                         |
-- +------------------------------------------------------------------------------+
-- | global vNestingLevel                  - profondit della finestra corrente rispetto alla radice (INUTILIZZATA, presente per identit formale con le procedure della WIP suite)
-- | vRootFolder                           - Contiene la cartella radice da disporre
-- | vFlagCurrentWindowsExitsFromTheScreen - Una sentinella sull'uscita di una finestra dallo schermo corrente
-- | vDesktopPositionX                     - Posizione orizzontale del Desktop (Cambia da utente ad utente!)
-- | vDesktopPositionY                     - Posizione verticale del Desktop
-- +------------------------------------------------------------------------------+

-- +-----+------------------------------------------------------------------------+
-- | BGN | Inizializzazioni                                                       |

-- +---( GLocals )----------------------------------------------------------------+
global vFinderVersion

-- la distanza reciproca tra le finestre (e dalla MenuBar) cambia con la verisone del Finder e tra utenti (root e gli altri)...
global kWindowsDistanceX -- distanza orizzontale tra la finestra ed il Desktop
global kWindowsDistanceY -- distanza verticale tra la finestra ed il Desktop (in realt dalla MenuBar)

global kWindowsDeltaX -- distanza orizzontale dalla finestra madre
global kWindowsDeltaY -- distanza verticale dalla finestra madre

-- global vNestingLevel -- profondit della finestra corrente rispetto alla radice
-- +------------------------------------------------------------------------------+
set vFinderVersion to version of application "Finder" -- Chiede la versione del Finder

if (vFinderVersion < "10.5") then
	set kWindowsDistanceX to 10 -- tipico fino al Mac OS X 10.3
	set kWindowsDistanceY to 88 -- tipico fino al Mac OS X 10.3
else
	set kWindowsDistanceX to 5 -- tipico da Mac OS X 10.4 ->
	set kWindowsDistanceY to 50 -- tipico da Mac OS X 10.4 ->
end if
-- | END | Inizializzazioni                                                       |
-- +-----+------------------------------------------------------------------------+


-- +-----+------------------------------------------------------------------------+
-- | BGN | Algoritmo principale                                                   |
tell application "Finder"
	
	select window of desktop -- sceglie il Desktop
	copy bounds of container window of desktop to {vDesktopPositionX, vDesktopPositionY, vDesktopWidth, vDesktopHeight} -- Ottiene posizione e dimensioni del Desktop (dunque funziona su qualunque monitor): la posizione VARIA con l'utente...	
	
	-- +-----+------------------------------------------------------------------------+
	-- | BGN | Chiede di scegliere la finestra radice                                 |
	try
		set vRootFolder to choose folder with prompt "Seleziona la cartella radice"
	on error -- in caso di errore (ad esempio: operazione annullata dall'utente)
		beep -- avverte ed ...
		return -- ... esce dal programma
	end try
	
	my pPlaceOneWindow(vRootFolder, 
		vDesktopPositionX, vDesktopPositionY, 
		0, 
		vDesktopWidth, vDesktopHeight) -- chiama la procedura di disposizione con VNestingLevel = 0 (La procedura  formalmente identica ad una sua omologa ricorsiva)
	
end tell -- application "Finder"
-- | END | Algoritmo principale                                                   |
-- +-----+------------------------------------------------------------------------+


-- +-----+------------------------------------------------------------------------+
-- | BGN | Procedura PPlaceWindow: disposizione della finestra                    |
on pPlaceOneWindow(vCurrentFolder, 
	vRootfolderUpperLeftCornerX, vRootfolderUpperLeftCornerY, 
	vNestingLevel, 
	vDesktopWidth, vDesktopHeight)
	
	tell application "Finder"
		
		try
			
			set vCurrentFolderWindow to make new Finder window to folder vCurrentFolder -- per essere usate le finestre devono essere aperte!
			
			-- +---+--------------------------------------------------------------------------+
			-- | R | 20080224 1932: BUG: Lo Zoom delle finestre nel 10.4 ha il valore opposto |
			if vFinderVersion < "10.5" then
				set zoomed of vCurrentFolderWindow to false -- imposta lo zoom della finestra correntemente trattata a FALSE (Lo so, lo so... non ci sono parole)
			else
				set zoomed of vCurrentFolderWindow to true -- imposta lo zoom della finestra correntemente trattata a "true"
			end if
			-- | REND |                                                                       |
			-- +------+-----------------------------------------------------------------------+
			
			set position of vCurrentFolderWindow to 
				{(vRootfolderUpperLeftCornerX + (kWindowsDistanceX)), 
					(vRootfolderUpperLeftCornerY + (kWindowsDistanceY))} -- imposta la posizione della finestra correntemente trattata
			
			copy bounds of container window of vCurrentFolder to 
				{vCurrentFolderUpperLeftCornerX, vCurrentFolderUpperLeftCornerY, 
					vCurrentFolderLowerRightCornerX, vCurrentFolderLowerRightCornerY} -- Ottiene posizione e dimensioni della finestra corrente
			
			-- +-----+------------------------------------------------------------------------+
			-- | BGN | controlla che la finestra delle cartella corrente non sia uscita dallo |
			-- |       schermo a seguito del riposizionamento                                 |
			set vFlagCurrentWindowsExitsFromTheScreen to false -- Annulla la variabile sentinella...
			
			if (vCurrentFolderLowerRightCornerX > vDesktopWidth) then -- la finestra esce a destra...
				set vCurrentFolderLowerRightCornerX to (vDesktopWidth - 5)
				set vFlagCurrentWindowsExitsFromTheScreen to true -- allarma il codice
			end if
			
			if (vCurrentFolderLowerRightCornerY > vDesktopHeight) then -- la finestra esce sotto...
				set vCurrentFolderLowerRightCornerY to (vDesktopHeight - 5)
				set vFlagCurrentWindowsExitsFromTheScreen to true -- allarma il codice
			end if
			
			if (vFlagCurrentWindowsExitsFromTheScreen = true) then -- Se la finestra esce dallo schermo (la variabile sentinella  allarmata...)
				set the bounds of the container window of vCurrentFolder to 
					{vCurrentFolderUpperLeftCornerX, vCurrentFolderUpperLeftCornerY, 
						vCurrentFolderLowerRightCornerX, vCurrentFolderLowerRightCornerY} -- Posiziona la finestra interamente dentro lo schermo...
				
				set vFlagCurrentWindowsExitsFromTheScreen to false -- ... cessato allarme
			end if
			-- | END | controlla che la finestra delle cartella corrente non sia uscita...    |
			-- +-----+------------------------------------------------------------------------+
			
			-- +---+--------------------------------------------------------------------------+
			-- | R | 20080224 1243                                                            |
			if (vFinderVersion < "10.5") then -- il WA non deve essere eseguito dal 10.5.x in poi...
				-- +-----+------------------------------------------------------------------------+
				-- | BGN | 20051102: Dave Lyons suggerisce un WA per far funzionare wIP su 10.4.x |
				set toolbar visible of vCurrentFolderWindow to not toolbar visible of vCurrentFolderWindow -- WA: 20051102 by Dave Lyons
				set toolbar visible of vCurrentFolderWindow to not toolbar visible of vCurrentFolderWindow -- WA: 20051102 by Dave Lyons
				-- | END | 20051102: Dave Lyons suggerisce un WA per far funzionare wIP su 10.4.x |
				-- +-----+------------------------------------------------------------------------+
			end if
			-- | REND |                                                                       |
			-- +------+-----------------------------------------------------------------------+
			
			close vCurrentFolderWindow -- chiude la finestra corrente
			
		on error -- Se prende errore...
			beep -- ...pu solo fare Beep :)
		end try -- Quindi avverte ed esce dal loop.
		
	end tell -- application "Finder"
	
end pPlaceOneWindow
-- | END | Procedura ricorsiva PPlaceWindow: disposizione delle finestre          |
-- +-----+------------------------------------------------------------------------+